using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Grid;

namespace DateTimeFormatGridList
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridListControl gridListControl1;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button button2;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridListControl1 = new Syncfusion.Windows.Forms.Grid.GridListControl();
			this.button1 = new System.Windows.Forms.Button();
			this.button2 = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.gridListControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridListControl1
			// 
			this.gridListControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridListControl1.BackColor = System.Drawing.SystemColors.Control;
			this.gridListControl1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.gridListControl1.ItemHeight = 17;
			this.gridListControl1.Location = new System.Drawing.Point(8, 64);
			this.gridListControl1.MultiColumn = false;
			this.gridListControl1.Name = "gridListControl1";
			this.gridListControl1.Properties.BackgroundColor = System.Drawing.SystemColors.Window;
			this.gridListControl1.SelectedIndex = -1;
			this.gridListControl1.Size = new System.Drawing.Size(396, 336);
			this.gridListControl1.TabIndex = 0;
			this.gridListControl1.TopIndex = 1;
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(208, 24);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(168, 24);
			this.button1.TabIndex = 1;
			this.button1.Text = "Apply the ResizeToFit method";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// button2
			// 
			this.button2.Location = new System.Drawing.Point(24, 24);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(168, 24);
			this.button2.TabIndex = 2;
			this.button2.Text = "Set width of the first column";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(408, 406);
			this.Controls.Add(this.button2);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.gridListControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridListControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			#region Get the DataSource
			DataTable dt = new DataTable("MyTable");

			int nCols = 4;
			int nRows = 20;
			Random r = new Random(123345345);

			dt.Columns.Add(new DataColumn(string.Format("DateTime{0}", 0), typeof(DateTime)));
			dt.Columns.Add(new DataColumn(string.Format("Col{0}", 1), typeof(string)));
			dt.Columns.Add(new DataColumn(string.Format("Col{0}", 2), typeof(double)));
			dt.Columns.Add(new DataColumn(string.Format("Col{0}", 3), typeof(double)));

			int dateNum = -20;
			string historyType = "Trader";
			DateTime date = DateTime.Now.Date.AddDays(dateNum);
			for(int i = 0; i < nRows; ++i) 
			{
				DataRow dr = dt.NewRow();
				dr[0] = date.AddDays(i);
				dr[1] = historyType;
				dr[2] = 10;
				dr[3] = 20;
				dt.Rows.Add(dr);
			}

				#endregion
			this.gridListControl1.DataSource = dt;
			this.gridListControl1.MultiColumn = true;
 
			this.gridListControl1.Grid.PrepareViewStyleInfo +=new Syncfusion.Windows.Forms.Grid.GridPrepareViewStyleInfoEventHandler(Grid_PrepareViewStyleInfo);   
		}

		private void Grid_PrepareViewStyleInfo(object sender, Syncfusion.Windows.Forms.Grid.GridPrepareViewStyleInfoEventArgs e)
		{
			if( e.RowIndex > 0 && e.ColIndex == 1)
			{
				e.Style.Format ="t"; 
			}
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			this.gridListControl1.Grid.Model.ColWidths.ResizeToFit(GridRangeInfo.Table());    
		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			this.gridListControl1.Grid.Model.ColWidths[2] = 200; 
		}
	}
}
